const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const employee_assignments = sequelize.define(
    'employee_assignments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

type: {
        type: DataTypes.ENUM,
      
      

        values: [

"DRIVER",


"DISPATCHER",


"ACCOUNTING",


"OTHER"

        ],

      },

title: {
        type: DataTypes.TEXT,
      
      

      },

valid_from: {
        type: DataTypes.DATE,
      
      

      },

valid_to: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  employee_assignments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















































//end loop



    db.employee_assignments.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });




    db.employee_assignments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.employee_assignments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return employee_assignments;
};


